#include <iostream>
#include <cstdlib>
#include <algorithm>

using namespace std;

int x;

void UcitavanjeBrojeva(int reseniSlucajevi, int nereseniSlucajevi)
{
    int nizZaReseneSlucajeve[200];
        int nizZaNereseneSlucajeve[200];

        for(int j=0; j<reseniSlucajevi; j++)
        {
            cin>>nizZaReseneSlucajeve[j];
        }

        for(int j=0; j<nereseniSlucajevi;j++)
        {
            cin>>nizZaNereseneSlucajeve[j];
        }
    int matrix[200][200];
    int matrixNereseni[200][200];

    for(int i=0; i<reseniSlucajevi; i++)
    {
        int w=0;
        for(int k=0; k<reseniSlucajevi; k++)
        {
            if(i!=k)
            {
                matrix[i][w]=abs(nizZaReseneSlucajeve[k]-nizZaReseneSlucajeve[i]);
                w++;
            }
         }
    }

    int najmanjaPromenljiva=matrix[0][0];

    for(int i=0; i<reseniSlucajevi; i++)
    {
        for(int k=0; k<(reseniSlucajevi-1); k++)
        {
            if(matrix[i][k]<najmanjaPromenljiva)
                najmanjaPromenljiva=matrix[i][k];
        }
    }

        int randomPromenljiva=0;

        for(int i=0; i<reseniSlucajevi; i++)
        {
            for(int k=0; k<(reseniSlucajevi-1); k++)
            {
                if((matrix[i][k]%najmanjaPromenljiva)==0)
                {
                    randomPromenljiva++;
                }
            }
        }

        int d=reseniSlucajevi*(reseniSlucajevi-1);

        if(randomPromenljiva!=d)
            x=0;
        else
        {
            int najmanjaTrazena=nizZaReseneSlucajeve[0];

            for(int j=0; j<reseniSlucajevi; j++)
            {
                if(nizZaReseneSlucajeve[j]<najmanjaTrazena)
                    najmanjaTrazena=nizZaReseneSlucajeve[j];
            }
            
            najmanjaTrazena=najmanjaTrazena%najmanjaPromenljiva;
            
            int s=najmanjaTrazena, y=0;

            for(int j=0; j<nereseniSlucajevi;j++)
            {
                s=najmanjaTrazena;
                
                while(nizZaNereseneSlucajeve[j]>s)
                {
                    s=s+najmanjaPromenljiva;
                }
                
                if(nizZaNereseneSlucajeve[j]==s)
                {
                    y++;
                }
            }
            
            if(y==0)
            {
                x=1;
            }
            else
            {
                x=0;
            }
        }
}

int main()
{
    int posetioci;
    int resenja[200];
    int reseniSlucajevi, nereseniSlucajevi;

    cin>>posetioci;

    for(int u=0; u<posetioci; u++)
    {
        cin>>reseniSlucajevi>>nereseniSlucajevi;
        UcitavanjeBrojeva(reseniSlucajevi, nereseniSlucajevi);
        resenja[u]=x;
    }

    for(int u=0; u<posetioci; u++)
    {
        cout<<resenja[u]<<endl;
    }

    return 0;
}